use std::fs::File;
use std::io::prelude::*;

use lalrpop_util::lalrpop_mod;

lalrpop_mod!(pub parser, "/ast/parser.rs");

use parser::*;

pub mod ast;

fn main() {}

pub fn read(file_name: &str) -> std::io::Result<String> {
    let mut file = File::open(file_name)?;
    let mut contents = String::new();
    file.read_to_string(&mut contents)?;
    Ok(contents)
}

pub fn parse(file_name: &str) {
    let p = read(file_name).expect("File not found");
    ProgramParser::new().parse(&p).unwrap()
}

#[test]
fn syntax() {
    parse("examples/syntax.rs");
}

#[test]
fn syntax2() {
    parse("examples/syntax2.rs");
}

#[test]
fn syntax3() {
    parse("examples/syntax3.rs");
}

#[test]
fn syntax4() {
    parse("examples/syntax4.rs");
}
